Package com.google.protobuf

# Class Field

java.lang.Object
com.google.protobuf.AbstractMessageLite
com.google.protobuf.AbstractMessage
com.google.protobuf.GeneratedMessage
com.google.protobuf.Field

All Implemented Interfaces:
  `FieldOrBuilder`, `Message`, `MessageLite`, `MessageLiteOrBuilder`, `MessageOrBuilder`, `Serializable`

public final class Field extends GeneratedMessage implements FieldOrBuilder
Protobuf type `google.protobuf.Field`

See Also:
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static final class`
`Field.Builder`
Protobuf type `google.protobuf.Field`
`static enum`
`Field.Cardinality`
Protobuf enum `google.protobuf.Field.Cardinality`
`static enum`
`Field.Kind`
Protobuf enum `google.protobuf.Field.Kind`

## Nested classes/interfaces inherited from class com.google.protobuf.GeneratedMessage

`GeneratedMessage.ExtendableBuilder<MessageT extends GeneratedMessage.ExtendableMessage<MessageT>,BuilderT extends GeneratedMessage.ExtendableBuilder<MessageT,BuilderT>>, GeneratedMessage.ExtendableMessage<MessageT extends GeneratedMessage.ExtendableMessage<MessageT>>, GeneratedMessage.ExtendableMessageOrBuilder<MessageT extends GeneratedMessage.ExtendableMessage<MessageT>>, GeneratedMessage.FieldAccessorTable, GeneratedMessage.GeneratedExtension<ContainingT extends Message,T>, GeneratedMessage.UnusedPrivateParameter`

## Nested classes/interfaces inherited from class com.google.protobuf.AbstractMessage

`AbstractMessage.BuilderParent`

## Nested classes/interfaces inherited from class com.google.protobuf.AbstractMessageLite

`AbstractMessageLite.InternalOneOfEnum`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`CARDINALITY_FIELD_NUMBER`
`static final int`
`DEFAULT_VALUE_FIELD_NUMBER`
`static final int`
`JSON_NAME_FIELD_NUMBER`
`static final int`
`KIND_FIELD_NUMBER`
`static final int`
`NAME_FIELD_NUMBER`
`static final int`
`NUMBER_FIELD_NUMBER`
`static final int`
`ONEOF_INDEX_FIELD_NUMBER`
`static final int`
`OPTIONS_FIELD_NUMBER`
`static final int`
`PACKED_FIELD_NUMBER`
`static final int`
`TYPE_URL_FIELD_NUMBER`

### Fields inherited from class com.google.protobuf.GeneratedMessage

`alwaysUseFieldBuilders, unknownFields`

### Fields inherited from class com.google.protobuf.AbstractMessage

`memoizedSize`

### Fields inherited from class com.google.protobuf.AbstractMessageLite

`memoizedHashCode`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`equals(Object obj)`
Compares the specified object with this message for equality.
`Field.Cardinality`
`getCardinality()`
`.google.protobuf.Field.Cardinality cardinality = 2 [json_name = "cardinality"];`
`int`
`getCardinalityValue()`
`.google.protobuf.Field.Cardinality cardinality = 2 [json_name = "cardinality"];`
`static Field`
`getDefaultInstance()`
`Field`
`getDefaultInstanceForType()`
Get an instance of the type with no fields set.
`String`
`getDefaultValue()`
`string default_value = 11 [json_name = "defaultValue"];`
`ByteString`
`getDefaultValueBytes()`
`string default_value = 11 [json_name = "defaultValue"];`
`static final Descriptors.Descriptor`
`getDescriptor()`
`String`
`getJsonName()`
`string json_name = 10 [json_name = "jsonName"];`
`ByteString`
`getJsonNameBytes()`
`string json_name = 10 [json_name = "jsonName"];`
`Field.Kind`
`getKind()`
`.google.protobuf.Field.Kind kind = 1 [json_name = "kind"];`
`int`
`getKindValue()`
`.google.protobuf.Field.Kind kind = 1 [json_name = "kind"];`
`String`
`getName()`
`string name = 4 [json_name = "name"];`
`ByteString`
`getNameBytes()`
`string name = 4 [json_name = "name"];`
`int`
`getNumber()`
`int32 number = 3 [json_name = "number"];`
`int`
`getOneofIndex()`
`int32 oneof_index = 7 [json_name = "oneofIndex"];`
`Option`
`getOptions(int index)`
`repeated .google.protobuf.Option options = 9 [json_name = "options"];`
`int`
`getOptionsCount()`
`repeated .google.protobuf.Option options = 9 [json_name = "options"];`
`List<Option>`
`getOptionsList()`
`repeated .google.protobuf.Option options = 9 [json_name = "options"];`
`OptionOrBuilder`
`getOptionsOrBuilder(int index)`
`repeated .google.protobuf.Option options = 9 [json_name = "options"];`
`List<? extends OptionOrBuilder>`
`getOptionsOrBuilderList()`
`repeated .google.protobuf.Option options = 9 [json_name = "options"];`
`boolean`
`getPacked()`
`bool packed = 8 [json_name = "packed"];`
`Parser<Field>`
`getParserForType()`
TODO: Remove this unnecessary intermediate implementation of this method.
`int`
`getSerializedSize()`
Get the number of bytes required to encode this message.
`String`
`getTypeUrl()`
`string type_url = 6 [json_name = "typeUrl"];`
`ByteString`
`getTypeUrlBytes()`
`string type_url = 6 [json_name = "typeUrl"];`
`int`
`hashCode()`
Returns the hash code value for this message.
`protected GeneratedMessage.FieldAccessorTable`
`internalGetFieldAccessorTable()`
Get the FieldAccessorTable for this type.
`final boolean`
`isInitialized()`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.
`static Field.Builder`
`newBuilder()`
`static Field.Builder`
`newBuilder(Field prototype)`
`Field.Builder`
`newBuilderForType()`
Constructs a new builder for a message of the same type as this message.
`protected Field.Builder`
`newBuilderForType(AbstractMessage.BuilderParent parent)`
Create a nested builder.
`static Field`
`parseDelimitedFrom(InputStream input)`
`static Field`
`parseDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry)`
`static Field`
`parseFrom(byte[] data)`
`static Field`
`parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry)`
`static Field`
`parseFrom(ByteString data)`
`static Field`
`parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry)`
`static Field`
`parseFrom(CodedInputStream input)`
`static Field`
`parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry)`
`static Field`
`parseFrom(InputStream input)`
`static Field`
`parseFrom(InputStream input, ExtensionRegistryLite extensionRegistry)`
`static Field`
`parseFrom(ByteBuffer data)`
`static Field`
`parseFrom(ByteBuffer data, ExtensionRegistryLite extensionRegistry)`
`static Parser<Field>`
`parser()`
`Field.Builder`
`toBuilder()`
Constructs a builder initialized with the current message.
`void`
`writeTo(CodedOutputStream output)`
Serializes the message and writes it to `output`.

### Methods inherited from class com.google.protobuf.GeneratedMessage

`canUseUnsafe, computeStringSize, computeStringSizeNoTag, emptyBooleanList, emptyDoubleList, emptyFloatList, emptyIntList, emptyList, emptyLongList, getAllFields, getDescriptorForType, getField, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof, internalGetMapField, internalGetMapFieldReflection, isStringEmpty, makeMutableCopy, makeMutableCopy, mergeFromAndMakeImmutableInternal, newFileScopedGeneratedExtension, newInstance, newMessageScopedGeneratedExtension, parseDelimitedWithIOException, parseDelimitedWithIOException, parseUnknownField, parseUnknownFieldProto3, parseWithIOException, parseWithIOException, parseWithIOException, parseWithIOException, serializeBooleanMapTo, serializeIntegerMapTo, serializeLongMapTo, serializeStringMapTo, writeReplace, writeString, writeStringNoTag`

### Methods inherited from class com.google.protobuf.AbstractMessage

`findInitializationErrors, getInitializationErrorString, hashFields, toString`

### Methods inherited from class com.google.protobuf.AbstractMessageLite

`addAll, checkByteStringIsUtf8, toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface com.google.protobuf.MessageLite

`toByteArray, toByteString, writeDelimitedTo, writeTo`

### Methods inherited from interface com.google.protobuf.MessageOrBuilder

`findInitializationErrors, getAllFields, getDescriptorForType, getField, getInitializationErrorString, getOneofFieldDescriptor, getRepeatedField, getRepeatedFieldCount, getUnknownFields, hasField, hasOneof`

## Field Details

### KIND_FIELD_NUMBER

public static final int KIND_FIELD_NUMBER

See Also:
  - Constant Field Values

### CARDINALITY_FIELD_NUMBER

public static final int CARDINALITY_FIELD_NUMBER

See Also:
  - Constant Field Values

### NUMBER_FIELD_NUMBER

public static final int NUMBER_FIELD_NUMBER

See Also:
  - Constant Field Values

### NAME_FIELD_NUMBER

public static final int NAME_FIELD_NUMBER

See Also:
  - Constant Field Values

### TYPE_URL_FIELD_NUMBER

public static final int TYPE_URL_FIELD_NUMBER

See Also:
  - Constant Field Values

### ONEOF_INDEX_FIELD_NUMBER

public static final int ONEOF_INDEX_FIELD_NUMBER

See Also:
  - Constant Field Values

### PACKED_FIELD_NUMBER

public static final int PACKED_FIELD_NUMBER

See Also:
  - Constant Field Values

### OPTIONS_FIELD_NUMBER

public static final int OPTIONS_FIELD_NUMBER

See Also:
  - Constant Field Values

### JSON_NAME_FIELD_NUMBER

public static final int JSON_NAME_FIELD_NUMBER

See Also:
  - Constant Field Values

### DEFAULT_VALUE_FIELD_NUMBER

public static final int DEFAULT_VALUE_FIELD_NUMBER

See Also:
  - Constant Field Values

## Method Details

### getDescriptor

public static final Descriptors.Descriptor getDescriptor()

### internalGetFieldAccessorTable

protected GeneratedMessage.FieldAccessorTable internalGetFieldAccessorTable()
Description copied from class: `GeneratedMessage`
Get the FieldAccessorTable for this type. We can't have the message class pass this in to the constructor because of bootstrapping trouble with DescriptorProtos.

Specified by:
  `internalGetFieldAccessorTable` in class `GeneratedMessage`

### getKindValue

public int getKindValue()
`.google.protobuf.Field.Kind kind = 1 [json_name = "kind"];`

Specified by:
  `getKindValue` in interface `FieldOrBuilder`
Returns:
  The enum numeric value on the wire for kind.

### getKind

public Field.Kind getKind()
`.google.protobuf.Field.Kind kind = 1 [json_name = "kind"];`

Specified by:
  `getKind` in interface `FieldOrBuilder`
Returns:
  The kind.

### getCardinalityValue

public int getCardinalityValue()
`.google.protobuf.Field.Cardinality cardinality = 2 [json_name = "cardinality"];`

Specified by:
  `getCardinalityValue` in interface `FieldOrBuilder`
Returns:
  The enum numeric value on the wire for cardinality.

### getCardinality

public Field.Cardinality getCardinality()
`.google.protobuf.Field.Cardinality cardinality = 2 [json_name = "cardinality"];`

Specified by:
  `getCardinality` in interface `FieldOrBuilder`
Returns:
  The cardinality.

### getNumber

public int getNumber()
`int32 number = 3 [json_name = "number"];`

Specified by:
  `getNumber` in interface `FieldOrBuilder`
Returns:
  The number.

### getName

public String getName()
`string name = 4 [json_name = "name"];`

Specified by:
  `getName` in interface `FieldOrBuilder`
Returns:
  The name.

### getNameBytes

public ByteString getNameBytes()
`string name = 4 [json_name = "name"];`

Specified by:
  `getNameBytes` in interface `FieldOrBuilder`
Returns:
  The bytes for name.

### getTypeUrl

public String getTypeUrl()
`string type_url = 6 [json_name = "typeUrl"];`

Specified by:
  `getTypeUrl` in interface `FieldOrBuilder`
Returns:
  The typeUrl.

### getTypeUrlBytes

public ByteString getTypeUrlBytes()
`string type_url = 6 [json_name = "typeUrl"];`

Specified by:
  `getTypeUrlBytes` in interface `FieldOrBuilder`
Returns:
  The bytes for typeUrl.

### getOneofIndex

public int getOneofIndex()
`int32 oneof_index = 7 [json_name = "oneofIndex"];`

Specified by:
  `getOneofIndex` in interface `FieldOrBuilder`
Returns:
  The oneofIndex.

### getPacked

public boolean getPacked()
`bool packed = 8 [json_name = "packed"];`

Specified by:
  `getPacked` in interface `FieldOrBuilder`
Returns:
  The packed.

### getOptionsList

public List<Option> getOptionsList()
`repeated .google.protobuf.Option options = 9 [json_name = "options"];`

Specified by:
  `getOptionsList` in interface `FieldOrBuilder`

### getOptionsOrBuilderList

public List<? extends OptionOrBuilder> getOptionsOrBuilderList()
`repeated .google.protobuf.Option options = 9 [json_name = "options"];`

Specified by:
  `getOptionsOrBuilderList` in interface `FieldOrBuilder`

### getOptionsCount

public int getOptionsCount()
`repeated .google.protobuf.Option options = 9 [json_name = "options"];`

Specified by:
  `getOptionsCount` in interface `FieldOrBuilder`

### getOptions

public Option getOptions(int index)
`repeated .google.protobuf.Option options = 9 [json_name = "options"];`

Specified by:
  `getOptions` in interface `FieldOrBuilder`

### getOptionsOrBuilder

public OptionOrBuilder getOptionsOrBuilder(int index)
`repeated .google.protobuf.Option options = 9 [json_name = "options"];`

Specified by:
  `getOptionsOrBuilder` in interface `FieldOrBuilder`

### getJsonName

public String getJsonName()
`string json_name = 10 [json_name = "jsonName"];`

Specified by:
  `getJsonName` in interface `FieldOrBuilder`
Returns:
  The jsonName.

### getJsonNameBytes

public ByteString getJsonNameBytes()
`string json_name = 10 [json_name = "jsonName"];`

Specified by:
  `getJsonNameBytes` in interface `FieldOrBuilder`
Returns:
  The bytes for jsonName.

### getDefaultValue

public String getDefaultValue()
`string default_value = 11 [json_name = "defaultValue"];`

Specified by:
  `getDefaultValue` in interface `FieldOrBuilder`
Returns:
  The defaultValue.

### getDefaultValueBytes

public ByteString getDefaultValueBytes()
`string default_value = 11 [json_name = "defaultValue"];`

Specified by:
  `getDefaultValueBytes` in interface `FieldOrBuilder`
Returns:
  The bytes for defaultValue.

### isInitialized

public final boolean isInitialized()
Description copied from interface: `MessageLiteOrBuilder`
Returns true if all required fields in the message and all embedded messages are set, false otherwise.

See also: `MessageOrBuilder.getInitializationErrorString()`

Specified by:
  `isInitialized` in interface `MessageLiteOrBuilder`
Overrides:
  `isInitialized` in class `GeneratedMessage`

### writeTo

public void writeTo(CodedOutputStream output) throws IOException
Description copied from interface: `MessageLite`
Serializes the message and writes it to `output`. This does not flush or close the stream.

Specified by:
  `writeTo` in interface `MessageLite`
Overrides:
  `writeTo` in class `GeneratedMessage`
Throws:
  `IOException`

### getSerializedSize

public int getSerializedSize()
Description copied from interface: `MessageLite`
Get the number of bytes required to encode this message. The result is only computed on the first call and memoized after that. If this message requires more than Integer.MAX_VALUE bytes to encode, the return value will be smaller than the actual number of bytes required and might be negative.

Specified by:
  `getSerializedSize` in interface `MessageLite`
Overrides:
  `getSerializedSize` in class `GeneratedMessage`

### equals

public boolean equals(Object obj)
Description copied from interface: `Message`
Compares the specified object with this message for equality. Returns `true` if the given object is a message of the same type (as defined by `getDescriptorForType()`) and has identical values for all of its fields. Subclasses must implement this; inheriting `Object.equals()` is incorrect.

Specified by:
  `equals` in interface `Message`
Overrides:
  `equals` in class `AbstractMessage`
Parameters:
  `obj` - object to be compared for equality with this message
Returns:
  `true` if the specified object is equal to this message

### hashCode

public int hashCode()
Description copied from interface: `Message`
Returns the hash code value for this message. The hash code of a message should mix the message's type (object identity of the descriptor) with its contents (known and unknown field values). Subclasses must implement this; inheriting `Object.hashCode()` is incorrect.

Specified by:
  `hashCode` in interface `Message`
Overrides:
  `hashCode` in class `AbstractMessage`
Returns:
  the hash code value for this message
See Also:
  - `Map.hashCode()`

### parseFrom

public static Field parseFrom(ByteBuffer data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Field parseFrom(ByteBuffer data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Field parseFrom(ByteString data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Field parseFrom(ByteString data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Field parseFrom(byte[] data) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Field parseFrom(byte[] data, ExtensionRegistryLite extensionRegistry) throws InvalidProtocolBufferException

Throws:
  `InvalidProtocolBufferException`

### parseFrom

public static Field parseFrom(InputStream input) throws IOException

Throws:
  `IOException`

### parseFrom

public static Field parseFrom(InputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### parseDelimitedFrom

public static Field parseDelimitedFrom(InputStream input) throws IOException

Throws:
  `IOException`

### parseDelimitedFrom

public static Field parseDelimitedFrom(InputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### parseFrom

public static Field parseFrom(CodedInputStream input) throws IOException

Throws:
  `IOException`

### parseFrom

public static Field parseFrom(CodedInputStream input, ExtensionRegistryLite extensionRegistry) throws IOException

Throws:
  `IOException`

### newBuilderForType

public Field.Builder newBuilderForType()
Description copied from interface: `MessageLite`
Constructs a new builder for a message of the same type as this message.

Specified by:
  `newBuilderForType` in interface `Message`
Specified by:
  `newBuilderForType` in interface `MessageLite`

### newBuilder

public static Field.Builder newBuilder()

### newBuilder

public static Field.Builder newBuilder(Field prototype)

### toBuilder

public Field.Builder toBuilder()
Description copied from interface: `MessageLite`
Constructs a builder initialized with the current message. Use this to derive a new message from the current one.

Specified by:
  `toBuilder` in interface `Message`
Specified by:
  `toBuilder` in interface `MessageLite`

### newBuilderForType

protected Field.Builder newBuilderForType(AbstractMessage.BuilderParent parent)
Description copied from class: `AbstractMessage`
Create a nested builder.

Overrides:
  `newBuilderForType` in class `AbstractMessage`

### getDefaultInstance

public static Field getDefaultInstance()

### parser

public static Parser<Field> parser()

### getParserForType

public Parser<Field> getParserForType()
Description copied from class: `GeneratedMessage`
TODO: Remove this unnecessary intermediate implementation of this method.

Specified by:
  `getParserForType` in interface `Message`
Specified by:
  `getParserForType` in interface `MessageLite`
Overrides:
  `getParserForType` in class `GeneratedMessage`

### getDefaultInstanceForType

public Field getDefaultInstanceForType()
Description copied from interface: `MessageLiteOrBuilder`
Get an instance of the type with no fields set. Because no fields are set, all getters for singular fields will return default values and repeated fields will appear empty. This may or may not be a singleton. This differs from the `getDefaultInstance()` method of generated message classes in that this method is an abstract method of the `MessageLite` interface whereas `getDefaultInstance()` is a static method of a specific class. They return the same thing.

Specified by:
  `getDefaultInstanceForType` in interface `MessageLiteOrBuilder`
Specified by:
  `getDefaultInstanceForType` in interface `MessageOrBuilder`